/* test generator uses testlib.h: https://github.com/MikeMirzayanov/testlib/blob/master/testlib.h
   arguments:
    - first - name of the test that will be generated
    - second - value of n
    - third - number of correct brackets
    - fourth - constant for controlling the bracket tree
    - fifth - number of queries
    - sixth - type of queries
        = 0 - random queries
        = 1 - change only further signs
        = 2 - change only speed limit signs to another speed limit
        = 3 - change only speed limit signs to undo
        = 4 - change only undo signs to speed limit
    - seventh, eighth, ... - used for seed for registerGen */
#include "testlib.h"
#include<iostream>
#include<unordered_set>
#include "test_generator.h"
#define MAXN 100000
#define MAXQ 100000
using namespace std;
vector <int> a[MAXN+1];
bool types[MAXN];
vector <bool> brackets;
void rec (int vr) {
    for (auto to : a[vr]) {
        brackets.push_back(false);
        rec(to);
        brackets.push_back(true);
    }
}
int dist[MAXN],signs[MAXN];
int balance[MAXN],suff[MAXN+1];
vector <pair <int, int> > queries;
int choose_speed (int ind, bool& same) {
    if ((signs[ind]!=-1)&&(same==true)) {
        same=false;
        return signs[ind];
    }
    for (;;) {
        int sign=rnd.next(10,119);
        if (signs[ind]!=sign) return sign;
    }
}
unordered_set <int> allspeeds1,speeds1,undos1,all1;
vector <int> allspeeds2,speeds2,undos2,all2;
int main (int argc, char** argv) {
    if (argc==1) {
       cout << "The test generator needs arguments!\n";
       return 0;
    }
    check_tests(argc,argv);
    if (argc<6) {
       cout << "The test generator needs more arguments!\n";
       return 0;
    }
    registerGen(argc,argv,1);
    ofstream fout(argv[1]);
    int n,k,t;
    n=atoll(argv[2]); k=atoll(argv[3]); t=atoll(argv[4]);
    int q,type;
    q=atoll(argv[5]); type=atoll(argv[6]);

    for (int i=1; i<k/2+1; i++) {
        a[rnd.wnext(i,t)].push_back(i);
    }
    rec(0);
    vector <int> inds(n);
    for (int i=0; i<n; i++) {
        inds[i]=i;
    }
    shuffle(inds.begin(),inds.end());
    sort(inds.begin(),inds.begin()+k);
    for (int i=0; i<k; i++) {
        types[inds[i]]=brackets[i];
    }
    int prv=0;
    for (int i=0; i<n; i++) {
        if (types[i]==false) {
            for (;;) {
                signs[i]=rnd.next(10,119);
                if ((i==0)||(signs[i]!=signs[i-1])) break;
            }
        }
        else signs[i]=-1;
        dist[i]=prv+rnd.next(1,100);
        prv=dist[i];
    }

    vector <int> active;
    active.push_back(120);
    for (int i=0; i<n; i++) {
        if (signs[i]==-1) active.pop_back();
        else active.push_back(signs[i]);
        balance[i]=active.size();
    }
    suff[n]=1e9;
    for (int i=n-1; i>=0; i--) {
        suff[i]=min(balance[i],suff[i+1]);
    }

    queries.reserve(q);
    for (int i=((type==1)?max(n-2000,0):0); i<n; i++) {
        all1.insert(i);
        all2.push_back(i);
        if (signs[i]!=-1) {
            allspeeds1.insert(i);
            allspeeds2.push_back(i);
            if (suff[i]>=3) {
                speeds1.insert(i);
                speeds2.push_back(i);
            }
        }
        else {
            undos1.insert(i);
            undos2.push_back(i);
        }
        if ((signs[i]==-1)&&(queries.empty()==true)&&((type==0)||(type==1))) queries.push_back({i, -1});
    }

    bool same=true;
    for (int i=queries.size(); i<q; i++) {
        if ((type==0)||(type==1)) {
            if ((speeds1.empty()==true)||(rnd.next(2)==0)) {
                if (all1.empty()) {
                    int ind=all2[rnd.next(all2.size())];
                    queries.push_back({ind, choose_speed(ind,same)});
                }
                else {
                    bool tmp=true;
                    queries.push_back({*all1.begin(), choose_speed(*all1.begin(),tmp)});
                    all1.erase(all1.begin());
                }
            }
            else {
                queries.push_back({*speeds1.begin(), -1});
                speeds1.erase(speeds1.begin());
            }
        }
        else if (type==2) {
            if (allspeeds1.empty()) {
                int ind=allspeeds2[rnd.next(allspeeds2.size())];
                queries.push_back({ind, choose_speed(ind,same)});
            }
            else {
                bool tmp=true;
                queries.push_back({*allspeeds1.begin(), choose_speed(*allspeeds1.begin(),tmp)});
                allspeeds1.erase(allspeeds1.begin());
            }
        }
        else if (type==3) {
            if (speeds1.empty()) queries.push_back({speeds2[rnd.next(speeds2.size())], -1});
            else {
                queries.push_back({*speeds1.begin(), -1});
                speeds1.erase(speeds1.begin());
            }
        }
        else if (type==4) {
            if (undos1.empty()) {
                int ind=undos2[rnd.next(undos2.size())];
                queries.push_back({ind, choose_speed(ind,same)});
            }
            else {
                queries.push_back({*undos1.begin(), choose_speed(*undos1.begin(),same)});
                undos1.erase(undos1.begin());
            }
        }
    }

    fout << n << " " << prv+rnd.next(1,100) << endl ;
    for (int i=0; i<n; i++) {
        fout << dist[i] << " " << signs[i] << endl ;
    }
    fout << q << endl ;
    shuffle(queries.begin(),queries.end());
    for (auto [ind, sign] : queries) {
        fout << ind+1 << " " << sign << endl ;
    }
    fout.close();

    cout << "test successfully generated!!!" << endl ;
    validate_test(argc,argv);
    return 0;
}
